// Implementation file for parser generated by fsyacc
module CPar
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open Microsoft.FSharp.Text.Lexing
open Microsoft.FSharp.Text.Parsing.ParseHelpers
# 1 "CPar.fsy"

(*	File ListC/CPar.fsy 
	Parser specification for list-C, a small imperative language with lists
	sestoft@itu.dk * 2009-10-18
	No (real) shift/reduce conflicts thanks to Niels Kokholm.
*)

open Absyn;

let compose1 f (g, s) = ((fun x -> g(f(x))), s)
let nl = CstI 10

# 19 "CPar.fs"
// This type is the type of tokens accepted by the parser
type token = 
  | EOF
  | LPAR
  | RPAR
  | LBRACE
  | RBRACE
  | LBRACK
  | RBRACK
  | SEMI
  | COMMA
  | ASSIGN
  | AMP
  | NOT
  | SEQOR
  | SEQAND
  | EQ
  | NE
  | GT
  | LT
  | GE
  | LE
  | PLUS
  | MINUS
  | TIMES
  | DIV
  | MOD
  | NIL
  | CONS
  | CAR
  | CDR
  | DYNAMIC
  | CHAR
  | ELSE
  | IF
  | INT
  | NULL
  | PRINT
  | PRINTLN
  | RETURN
  | VOID
  | WHILE
  | CSTSTRING of (string)
  | NAME of (string)
  | CSTINT of (int)
  | CSTBOOL of (int)
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_EOF
    | TOKEN_LPAR
    | TOKEN_RPAR
    | TOKEN_LBRACE
    | TOKEN_RBRACE
    | TOKEN_LBRACK
    | TOKEN_RBRACK
    | TOKEN_SEMI
    | TOKEN_COMMA
    | TOKEN_ASSIGN
    | TOKEN_AMP
    | TOKEN_NOT
    | TOKEN_SEQOR
    | TOKEN_SEQAND
    | TOKEN_EQ
    | TOKEN_NE
    | TOKEN_GT
    | TOKEN_LT
    | TOKEN_GE
    | TOKEN_LE
    | TOKEN_PLUS
    | TOKEN_MINUS
    | TOKEN_TIMES
    | TOKEN_DIV
    | TOKEN_MOD
    | TOKEN_NIL
    | TOKEN_CONS
    | TOKEN_CAR
    | TOKEN_CDR
    | TOKEN_DYNAMIC
    | TOKEN_CHAR
    | TOKEN_ELSE
    | TOKEN_IF
    | TOKEN_INT
    | TOKEN_NULL
    | TOKEN_PRINT
    | TOKEN_PRINTLN
    | TOKEN_RETURN
    | TOKEN_VOID
    | TOKEN_WHILE
    | TOKEN_CSTSTRING
    | TOKEN_NAME
    | TOKEN_CSTINT
    | TOKEN_CSTBOOL
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startMain
    | NONTERM_Main
    | NONTERM_Topdecs
    | NONTERM_Topdec
    | NONTERM_Vardec
    | NONTERM_Vardesc
    | NONTERM_Fundec
    | NONTERM_Paramdecs
    | NONTERM_Paramdecs1
    | NONTERM_Block
    | NONTERM_StmtOrDecSeq
    | NONTERM_Stmt
    | NONTERM_StmtM
    | NONTERM_StmtU
    | NONTERM_Expr
    | NONTERM_ExprNotAccess
    | NONTERM_AtExprNotAccess
    | NONTERM_Access
    | NONTERM_Exprs
    | NONTERM_Exprs1
    | NONTERM_Const
    | NONTERM_Type

// This function maps tokens to integers indexes
let tagOfToken (t:token) = 
  match t with
  | EOF  -> 0 
  | LPAR  -> 1 
  | RPAR  -> 2 
  | LBRACE  -> 3 
  | RBRACE  -> 4 
  | LBRACK  -> 5 
  | RBRACK  -> 6 
  | SEMI  -> 7 
  | COMMA  -> 8 
  | ASSIGN  -> 9 
  | AMP  -> 10 
  | NOT  -> 11 
  | SEQOR  -> 12 
  | SEQAND  -> 13 
  | EQ  -> 14 
  | NE  -> 15 
  | GT  -> 16 
  | LT  -> 17 
  | GE  -> 18 
  | LE  -> 19 
  | PLUS  -> 20 
  | MINUS  -> 21 
  | TIMES  -> 22 
  | DIV  -> 23 
  | MOD  -> 24 
  | NIL  -> 25 
  | CONS  -> 26 
  | CAR  -> 27 
  | CDR  -> 28 
  | DYNAMIC  -> 29 
  | CHAR  -> 30 
  | ELSE  -> 31 
  | IF  -> 32 
  | INT  -> 33 
  | NULL  -> 34 
  | PRINT  -> 35 
  | PRINTLN  -> 36 
  | RETURN  -> 37 
  | VOID  -> 38 
  | WHILE  -> 39 
  | CSTSTRING _ -> 40 
  | NAME _ -> 41 
  | CSTINT _ -> 42 
  | CSTBOOL _ -> 43 

// This function maps integers indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_EOF 
  | 1 -> TOKEN_LPAR 
  | 2 -> TOKEN_RPAR 
  | 3 -> TOKEN_LBRACE 
  | 4 -> TOKEN_RBRACE 
  | 5 -> TOKEN_LBRACK 
  | 6 -> TOKEN_RBRACK 
  | 7 -> TOKEN_SEMI 
  | 8 -> TOKEN_COMMA 
  | 9 -> TOKEN_ASSIGN 
  | 10 -> TOKEN_AMP 
  | 11 -> TOKEN_NOT 
  | 12 -> TOKEN_SEQOR 
  | 13 -> TOKEN_SEQAND 
  | 14 -> TOKEN_EQ 
  | 15 -> TOKEN_NE 
  | 16 -> TOKEN_GT 
  | 17 -> TOKEN_LT 
  | 18 -> TOKEN_GE 
  | 19 -> TOKEN_LE 
  | 20 -> TOKEN_PLUS 
  | 21 -> TOKEN_MINUS 
  | 22 -> TOKEN_TIMES 
  | 23 -> TOKEN_DIV 
  | 24 -> TOKEN_MOD 
  | 25 -> TOKEN_NIL 
  | 26 -> TOKEN_CONS 
  | 27 -> TOKEN_CAR 
  | 28 -> TOKEN_CDR 
  | 29 -> TOKEN_DYNAMIC 
  | 30 -> TOKEN_CHAR 
  | 31 -> TOKEN_ELSE 
  | 32 -> TOKEN_IF 
  | 33 -> TOKEN_INT 
  | 34 -> TOKEN_NULL 
  | 35 -> TOKEN_PRINT 
  | 36 -> TOKEN_PRINTLN 
  | 37 -> TOKEN_RETURN 
  | 38 -> TOKEN_VOID 
  | 39 -> TOKEN_WHILE 
  | 40 -> TOKEN_CSTSTRING 
  | 41 -> TOKEN_NAME 
  | 42 -> TOKEN_CSTINT 
  | 43 -> TOKEN_CSTBOOL 
  | 46 -> TOKEN_end_of_input
  | 44 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startMain 
    | 1 -> NONTERM_Main 
    | 2 -> NONTERM_Topdecs 
    | 3 -> NONTERM_Topdecs 
    | 4 -> NONTERM_Topdec 
    | 5 -> NONTERM_Topdec 
    | 6 -> NONTERM_Vardec 
    | 7 -> NONTERM_Vardesc 
    | 8 -> NONTERM_Vardesc 
    | 9 -> NONTERM_Vardesc 
    | 10 -> NONTERM_Vardesc 
    | 11 -> NONTERM_Vardesc 
    | 12 -> NONTERM_Fundec 
    | 13 -> NONTERM_Fundec 
    | 14 -> NONTERM_Paramdecs 
    | 15 -> NONTERM_Paramdecs 
    | 16 -> NONTERM_Paramdecs1 
    | 17 -> NONTERM_Paramdecs1 
    | 18 -> NONTERM_Block 
    | 19 -> NONTERM_StmtOrDecSeq 
    | 20 -> NONTERM_StmtOrDecSeq 
    | 21 -> NONTERM_StmtOrDecSeq 
    | 22 -> NONTERM_Stmt 
    | 23 -> NONTERM_Stmt 
    | 24 -> NONTERM_StmtM 
    | 25 -> NONTERM_StmtM 
    | 26 -> NONTERM_StmtM 
    | 27 -> NONTERM_StmtM 
    | 28 -> NONTERM_StmtM 
    | 29 -> NONTERM_StmtM 
    | 30 -> NONTERM_StmtU 
    | 31 -> NONTERM_StmtU 
    | 32 -> NONTERM_StmtU 
    | 33 -> NONTERM_Expr 
    | 34 -> NONTERM_Expr 
    | 35 -> NONTERM_ExprNotAccess 
    | 36 -> NONTERM_ExprNotAccess 
    | 37 -> NONTERM_ExprNotAccess 
    | 38 -> NONTERM_ExprNotAccess 
    | 39 -> NONTERM_ExprNotAccess 
    | 40 -> NONTERM_ExprNotAccess 
    | 41 -> NONTERM_ExprNotAccess 
    | 42 -> NONTERM_ExprNotAccess 
    | 43 -> NONTERM_ExprNotAccess 
    | 44 -> NONTERM_ExprNotAccess 
    | 45 -> NONTERM_ExprNotAccess 
    | 46 -> NONTERM_ExprNotAccess 
    | 47 -> NONTERM_ExprNotAccess 
    | 48 -> NONTERM_ExprNotAccess 
    | 49 -> NONTERM_ExprNotAccess 
    | 50 -> NONTERM_ExprNotAccess 
    | 51 -> NONTERM_ExprNotAccess 
    | 52 -> NONTERM_ExprNotAccess 
    | 53 -> NONTERM_ExprNotAccess 
    | 54 -> NONTERM_AtExprNotAccess 
    | 55 -> NONTERM_AtExprNotAccess 
    | 56 -> NONTERM_AtExprNotAccess 
    | 57 -> NONTERM_AtExprNotAccess 
    | 58 -> NONTERM_AtExprNotAccess 
    | 59 -> NONTERM_AtExprNotAccess 
    | 60 -> NONTERM_AtExprNotAccess 
    | 61 -> NONTERM_Access 
    | 62 -> NONTERM_Access 
    | 63 -> NONTERM_Access 
    | 64 -> NONTERM_Access 
    | 65 -> NONTERM_Access 
    | 66 -> NONTERM_Exprs 
    | 67 -> NONTERM_Exprs 
    | 68 -> NONTERM_Exprs1 
    | 69 -> NONTERM_Exprs1 
    | 70 -> NONTERM_Const 
    | 71 -> NONTERM_Const 
    | 72 -> NONTERM_Const 
    | 73 -> NONTERM_Const 
    | 74 -> NONTERM_Type 
    | 75 -> NONTERM_Type 
    | 76 -> NONTERM_Type 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 46 
let _fsyacc_tagOfErrorTerminal = 44

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | EOF  -> "EOF" 
  | LPAR  -> "LPAR" 
  | RPAR  -> "RPAR" 
  | LBRACE  -> "LBRACE" 
  | RBRACE  -> "RBRACE" 
  | LBRACK  -> "LBRACK" 
  | RBRACK  -> "RBRACK" 
  | SEMI  -> "SEMI" 
  | COMMA  -> "COMMA" 
  | ASSIGN  -> "ASSIGN" 
  | AMP  -> "AMP" 
  | NOT  -> "NOT" 
  | SEQOR  -> "SEQOR" 
  | SEQAND  -> "SEQAND" 
  | EQ  -> "EQ" 
  | NE  -> "NE" 
  | GT  -> "GT" 
  | LT  -> "LT" 
  | GE  -> "GE" 
  | LE  -> "LE" 
  | PLUS  -> "PLUS" 
  | MINUS  -> "MINUS" 
  | TIMES  -> "TIMES" 
  | DIV  -> "DIV" 
  | MOD  -> "MOD" 
  | NIL  -> "NIL" 
  | CONS  -> "CONS" 
  | CAR  -> "CAR" 
  | CDR  -> "CDR" 
  | DYNAMIC  -> "DYNAMIC" 
  | CHAR  -> "CHAR" 
  | ELSE  -> "ELSE" 
  | IF  -> "IF" 
  | INT  -> "INT" 
  | NULL  -> "NULL" 
  | PRINT  -> "PRINT" 
  | PRINTLN  -> "PRINTLN" 
  | RETURN  -> "RETURN" 
  | VOID  -> "VOID" 
  | WHILE  -> "WHILE" 
  | CSTSTRING _ -> "CSTSTRING" 
  | NAME _ -> "NAME" 
  | CSTINT _ -> "CSTINT" 
  | CSTBOOL _ -> "CSTBOOL" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | EOF  -> (null : System.Object) 
  | LPAR  -> (null : System.Object) 
  | RPAR  -> (null : System.Object) 
  | LBRACE  -> (null : System.Object) 
  | RBRACE  -> (null : System.Object) 
  | LBRACK  -> (null : System.Object) 
  | RBRACK  -> (null : System.Object) 
  | SEMI  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | ASSIGN  -> (null : System.Object) 
  | AMP  -> (null : System.Object) 
  | NOT  -> (null : System.Object) 
  | SEQOR  -> (null : System.Object) 
  | SEQAND  -> (null : System.Object) 
  | EQ  -> (null : System.Object) 
  | NE  -> (null : System.Object) 
  | GT  -> (null : System.Object) 
  | LT  -> (null : System.Object) 
  | GE  -> (null : System.Object) 
  | LE  -> (null : System.Object) 
  | PLUS  -> (null : System.Object) 
  | MINUS  -> (null : System.Object) 
  | TIMES  -> (null : System.Object) 
  | DIV  -> (null : System.Object) 
  | MOD  -> (null : System.Object) 
  | NIL  -> (null : System.Object) 
  | CONS  -> (null : System.Object) 
  | CAR  -> (null : System.Object) 
  | CDR  -> (null : System.Object) 
  | DYNAMIC  -> (null : System.Object) 
  | CHAR  -> (null : System.Object) 
  | ELSE  -> (null : System.Object) 
  | IF  -> (null : System.Object) 
  | INT  -> (null : System.Object) 
  | NULL  -> (null : System.Object) 
  | PRINT  -> (null : System.Object) 
  | PRINTLN  -> (null : System.Object) 
  | RETURN  -> (null : System.Object) 
  | VOID  -> (null : System.Object) 
  | WHILE  -> (null : System.Object) 
  | CSTSTRING _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | NAME _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | CSTINT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | CSTBOOL _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
let _fsyacc_gotos = [| 0us; 65535us; 1us; 65535us; 0us; 1us; 2us; 65535us; 0us; 2us; 4us; 5us; 2us; 65535us; 0us; 4us; 4us; 4us; 8us; 65535us; 0us; 6us; 4us; 6us; 25us; 34us; 29us; 34us; 35us; 34us; 37us; 42us; 40us; 42us; 43us; 42us; 4us; 65535us; 9us; 11us; 10us; 11us; 14us; 15us; 16us; 17us; 2us; 65535us; 0us; 8us; 4us; 8us; 2us; 65535us; 25us; 26us; 29us; 30us; 3us; 65535us; 25us; 33us; 29us; 33us; 35us; 36us; 8us; 65535us; 27us; 28us; 31us; 32us; 37us; 54us; 40us; 54us; 43us; 54us; 58us; 54us; 59us; 54us; 64us; 54us; 3us; 65535us; 37us; 38us; 40us; 41us; 43us; 44us; 4us; 65535us; 37us; 40us; 40us; 40us; 43us; 40us; 58us; 67us; 6us; 65535us; 37us; 45us; 40us; 45us; 43us; 45us; 58us; 46us; 59us; 60us; 64us; 65us; 6us; 65535us; 37us; 47us; 40us; 47us; 43us; 47us; 58us; 47us; 59us; 66us; 64us; 68us; 33us; 65535us; 37us; 48us; 40us; 48us; 43us; 48us; 50us; 52us; 56us; 57us; 58us; 48us; 59us; 48us; 62us; 63us; 64us; 48us; 74us; 75us; 77us; 104us; 80us; 81us; 82us; 83us; 105us; 85us; 106us; 86us; 107us; 87us; 108us; 88us; 109us; 89us; 110us; 90us; 111us; 91us; 112us; 92us; 113us; 93us; 114us; 94us; 115us; 95us; 116us; 96us; 117us; 98us; 119us; 97us; 125us; 99us; 126us; 100us; 129us; 101us; 132us; 102us; 141us; 103us; 144us; 104us; 33us; 65535us; 37us; 71us; 40us; 71us; 43us; 71us; 50us; 71us; 56us; 71us; 58us; 71us; 59us; 71us; 62us; 71us; 64us; 71us; 74us; 71us; 77us; 71us; 80us; 71us; 82us; 71us; 105us; 71us; 106us; 71us; 107us; 71us; 108us; 71us; 109us; 71us; 110us; 71us; 111us; 71us; 112us; 71us; 113us; 71us; 114us; 71us; 115us; 71us; 116us; 71us; 117us; 71us; 119us; 72us; 125us; 71us; 126us; 71us; 129us; 71us; 132us; 71us; 141us; 71us; 144us; 71us; 34us; 65535us; 37us; 73us; 40us; 73us; 43us; 73us; 50us; 73us; 56us; 73us; 58us; 73us; 59us; 73us; 62us; 73us; 64us; 73us; 74us; 73us; 77us; 73us; 80us; 73us; 82us; 73us; 105us; 73us; 106us; 73us; 107us; 73us; 108us; 73us; 109us; 73us; 110us; 73us; 111us; 73us; 112us; 73us; 113us; 73us; 114us; 73us; 115us; 73us; 116us; 73us; 117us; 73us; 119us; 73us; 125us; 73us; 126us; 73us; 129us; 73us; 132us; 73us; 138us; 140us; 141us; 73us; 144us; 73us; 36us; 65535us; 37us; 70us; 40us; 70us; 43us; 70us; 50us; 70us; 56us; 70us; 58us; 70us; 59us; 70us; 62us; 70us; 64us; 70us; 74us; 70us; 77us; 70us; 80us; 70us; 82us; 70us; 105us; 70us; 106us; 70us; 107us; 70us; 108us; 70us; 109us; 70us; 110us; 70us; 111us; 70us; 112us; 70us; 113us; 70us; 114us; 70us; 115us; 70us; 116us; 70us; 117us; 70us; 119us; 69us; 121us; 122us; 125us; 70us; 126us; 70us; 129us; 70us; 132us; 70us; 135us; 136us; 138us; 139us; 141us; 70us; 144us; 70us; 1us; 65535us; 77us; 78us; 2us; 65535us; 77us; 143us; 144us; 145us; 34us; 65535us; 37us; 118us; 40us; 118us; 43us; 118us; 50us; 118us; 56us; 118us; 58us; 118us; 59us; 118us; 62us; 118us; 64us; 118us; 74us; 118us; 77us; 118us; 80us; 118us; 82us; 118us; 105us; 118us; 106us; 118us; 107us; 118us; 108us; 118us; 109us; 118us; 110us; 118us; 111us; 118us; 112us; 118us; 113us; 118us; 114us; 118us; 115us; 118us; 116us; 118us; 117us; 118us; 119us; 118us; 125us; 118us; 126us; 118us; 129us; 118us; 132us; 118us; 138us; 118us; 141us; 118us; 144us; 118us; 8us; 65535us; 0us; 10us; 4us; 10us; 25us; 9us; 29us; 9us; 35us; 9us; 37us; 9us; 40us; 9us; 43us; 9us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 3us; 6us; 9us; 18us; 23us; 26us; 29us; 33us; 42us; 46us; 51us; 58us; 65us; 99us; 133us; 168us; 205us; 207us; 210us; 245us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 1us; 1us; 3us; 1us; 3us; 1us; 4us; 1us; 4us; 1us; 5us; 1us; 6us; 2us; 6us; 13us; 3us; 6us; 10us; 11us; 1us; 7us; 2us; 7us; 13us; 1us; 8us; 3us; 8us; 10us; 11us; 1us; 9us; 3us; 9us; 10us; 11us; 1us; 9us; 2us; 10us; 11us; 1us; 10us; 1us; 11us; 1us; 11us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 12us; 1us; 13us; 1us; 13us; 1us; 13us; 1us; 13us; 1us; 15us; 2us; 16us; 17us; 1us; 17us; 1us; 17us; 1us; 18us; 1us; 18us; 1us; 18us; 1us; 20us; 1us; 20us; 1us; 21us; 1us; 21us; 1us; 21us; 1us; 22us; 3us; 22us; 28us; 30us; 1us; 23us; 14us; 24us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 1us; 24us; 2us; 25us; 26us; 1us; 25us; 14us; 26us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 1us; 26us; 1us; 27us; 3us; 28us; 30us; 31us; 3us; 28us; 30us; 31us; 16us; 28us; 30us; 31us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 3us; 28us; 30us; 31us; 2us; 28us; 30us; 1us; 28us; 2us; 29us; 32us; 2us; 29us; 32us; 15us; 29us; 32us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 2us; 29us; 32us; 1us; 29us; 1us; 30us; 1us; 31us; 1us; 32us; 4us; 33us; 36us; 62us; 65us; 3us; 33us; 36us; 65us; 1us; 34us; 2us; 34us; 55us; 1us; 35us; 1us; 36us; 14us; 36us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 2us; 37us; 61us; 1us; 37us; 1us; 37us; 1us; 37us; 1us; 38us; 14us; 38us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 1us; 39us; 14us; 39us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 1us; 40us; 14us; 41us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 52us; 53us; 13us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 53us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 58us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 58us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 59us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 60us; 14us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 65us; 15us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 48us; 49us; 50us; 51us; 52us; 53us; 68us; 69us; 1us; 41us; 1us; 42us; 1us; 43us; 1us; 44us; 1us; 45us; 1us; 46us; 1us; 47us; 1us; 48us; 1us; 49us; 1us; 50us; 1us; 51us; 1us; 52us; 1us; 53us; 1us; 54us; 2us; 55us; 62us; 1us; 55us; 1us; 56us; 2us; 56us; 65us; 1us; 57us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 58us; 1us; 59us; 1us; 59us; 1us; 59us; 1us; 60us; 1us; 60us; 1us; 60us; 1us; 61us; 1us; 62us; 2us; 62us; 65us; 1us; 62us; 2us; 63us; 64us; 2us; 63us; 65us; 1us; 64us; 1us; 65us; 1us; 65us; 1us; 67us; 1us; 69us; 1us; 69us; 1us; 70us; 1us; 71us; 1us; 72us; 1us; 72us; 1us; 73us; 1us; 74us; 1us; 75us; 1us; 76us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 10us; 12us; 14us; 16us; 18us; 20us; 23us; 27us; 29us; 32us; 34us; 38us; 40us; 44us; 46us; 49us; 51us; 53us; 55us; 57us; 59us; 61us; 63us; 65us; 67us; 69us; 71us; 73us; 75us; 77us; 80us; 82us; 84us; 86us; 88us; 90us; 92us; 94us; 96us; 98us; 100us; 102us; 106us; 108us; 123us; 125us; 128us; 130us; 145us; 147us; 149us; 153us; 157us; 174us; 178us; 181us; 183us; 186us; 189us; 205us; 208us; 210us; 212us; 214us; 216us; 221us; 225us; 227us; 230us; 232us; 234us; 249us; 252us; 254us; 256us; 258us; 260us; 275us; 277us; 292us; 294us; 309us; 324us; 339us; 354us; 369us; 384us; 399us; 414us; 429us; 444us; 459us; 474us; 488us; 503us; 518us; 533us; 548us; 563us; 578us; 594us; 596us; 598us; 600us; 602us; 604us; 606us; 608us; 610us; 612us; 614us; 616us; 618us; 620us; 622us; 625us; 627us; 629us; 632us; 634us; 636us; 638us; 640us; 642us; 644us; 646us; 648us; 650us; 652us; 654us; 656us; 658us; 661us; 663us; 666us; 669us; 671us; 673us; 675us; 677us; 679us; 681us; 683us; 685us; 687us; 689us; 691us; 693us; 695us; |]
let _fsyacc_action_rows = 154
let _fsyacc_actionTableElements = [|4us; 16386us; 29us; 153us; 30us; 152us; 33us; 151us; 38us; 23us; 0us; 49152us; 1us; 32768us; 0us; 3us; 0us; 16385us; 4us; 16386us; 29us; 153us; 30us; 152us; 33us; 151us; 38us; 23us; 0us; 16387us; 1us; 32768us; 7us; 7us; 0us; 16388us; 0us; 16389us; 3us; 32768us; 1us; 16us; 22us; 14us; 41us; 12us; 3us; 32768us; 1us; 16us; 22us; 14us; 41us; 13us; 1us; 16390us; 5us; 19us; 0us; 16391us; 1us; 16391us; 1us; 29us; 3us; 32768us; 1us; 16us; 22us; 14us; 41us; 12us; 1us; 16392us; 5us; 19us; 3us; 32768us; 1us; 16us; 22us; 14us; 41us; 12us; 2us; 32768us; 2us; 18us; 5us; 19us; 0us; 16393us; 2us; 32768us; 6us; 20us; 42us; 21us; 0us; 16394us; 1us; 32768us; 6us; 22us; 0us; 16395us; 1us; 32768us; 41us; 24us; 1us; 32768us; 1us; 25us; 3us; 16398us; 29us; 153us; 30us; 152us; 33us; 151us; 1us; 32768us; 2us; 27us; 1us; 32768us; 3us; 37us; 0us; 16396us; 3us; 16398us; 29us; 153us; 30us; 152us; 33us; 151us; 1us; 32768us; 2us; 31us; 1us; 32768us; 3us; 37us; 0us; 16397us; 0us; 16399us; 1us; 16400us; 8us; 35us; 3us; 32768us; 29us; 153us; 30us; 152us; 33us; 151us; 0us; 16401us; 22us; 16403us; 1us; 119us; 3us; 37us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 29us; 153us; 30us; 152us; 32us; 55us; 33us; 151us; 34us; 150us; 35us; 82us; 36us; 84us; 37us; 50us; 39us; 61us; 41us; 76us; 42us; 146us; 43us; 147us; 1us; 32768us; 4us; 39us; 0us; 16402us; 22us; 16403us; 1us; 119us; 3us; 37us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 29us; 153us; 30us; 152us; 32us; 55us; 33us; 151us; 34us; 150us; 35us; 82us; 36us; 84us; 37us; 50us; 39us; 61us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16404us; 1us; 32768us; 7us; 43us; 22us; 16403us; 1us; 119us; 3us; 37us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 29us; 153us; 30us; 152us; 32us; 55us; 33us; 151us; 34us; 150us; 35us; 82us; 36us; 84us; 37us; 50us; 39us; 61us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16405us; 0us; 16406us; 1us; 16406us; 31us; 59us; 0us; 16407us; 14us; 32768us; 7us; 49us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 0us; 16408us; 16us; 32768us; 1us; 119us; 7us; 51us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16409us; 14us; 32768us; 7us; 53us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 0us; 16410us; 0us; 16411us; 1us; 32768us; 1us; 56us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 14us; 32768us; 2us; 58us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 19us; 32768us; 1us; 119us; 3us; 37us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 32us; 55us; 34us; 150us; 35us; 82us; 36us; 84us; 37us; 50us; 39us; 61us; 41us; 76us; 42us; 146us; 43us; 147us; 19us; 32768us; 1us; 119us; 3us; 37us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 32us; 55us; 34us; 150us; 35us; 82us; 36us; 84us; 37us; 50us; 39us; 61us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16412us; 1us; 32768us; 1us; 62us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 14us; 32768us; 2us; 64us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 19us; 32768us; 1us; 119us; 3us; 37us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 32us; 55us; 34us; 150us; 35us; 82us; 36us; 84us; 37us; 50us; 39us; 61us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16413us; 0us; 16414us; 0us; 16415us; 0us; 16416us; 3us; 16417us; 2us; 137us; 5us; 141us; 9us; 74us; 2us; 16417us; 5us; 141us; 9us; 74us; 0us; 16418us; 1us; 16418us; 2us; 120us; 0us; 16419us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 13us; 16420us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 1us; 16445us; 1us; 77us; 15us; 16450us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 1us; 32768us; 2us; 79us; 0us; 16421us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16422us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 13us; 16423us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 0us; 16424us; 3us; 16425us; 22us; 107us; 23us; 108us; 24us; 109us; 3us; 16426us; 22us; 107us; 23us; 108us; 24us; 109us; 0us; 16427us; 0us; 16428us; 0us; 16429us; 9us; 16430us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 9us; 16431us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 9us; 16432us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 9us; 16433us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 9us; 16434us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 9us; 16435us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 11us; 16436us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 13us; 32768us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 12us; 16437us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 14us; 32768us; 8us; 126us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 14us; 32768us; 2us; 127us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 14us; 32768us; 2us; 130us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 14us; 32768us; 2us; 133us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 14us; 32768us; 6us; 142us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 14us; 16452us; 8us; 144us; 12us; 117us; 13us; 116us; 14us; 110us; 15us; 111us; 16us; 112us; 17us; 113us; 18us; 114us; 19us; 115us; 20us; 105us; 21us; 106us; 22us; 107us; 23us; 108us; 24us; 109us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16438us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16439us; 3us; 32768us; 1us; 135us; 22us; 138us; 41us; 134us; 1us; 16440us; 5us; 141us; 0us; 16441us; 1us; 32768us; 1us; 125us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16442us; 1us; 32768us; 1us; 129us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16443us; 1us; 32768us; 1us; 132us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16444us; 0us; 16445us; 3us; 32768us; 1us; 135us; 22us; 138us; 41us; 134us; 2us; 32768us; 2us; 137us; 5us; 141us; 0us; 16446us; 12us; 32768us; 1us; 119us; 10us; 121us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 41us; 134us; 42us; 146us; 43us; 147us; 1us; 16447us; 5us; 141us; 0us; 16448us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16449us; 0us; 16451us; 15us; 32768us; 1us; 119us; 10us; 121us; 11us; 80us; 21us; 148us; 22us; 138us; 25us; 123us; 26us; 124us; 27us; 128us; 28us; 131us; 34us; 150us; 35us; 82us; 36us; 84us; 41us; 76us; 42us; 146us; 43us; 147us; 0us; 16453us; 0us; 16454us; 0us; 16455us; 1us; 32768us; 42us; 149us; 0us; 16456us; 0us; 16457us; 0us; 16458us; 0us; 16459us; 0us; 16460us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 5us; 6us; 8us; 9us; 14us; 15us; 17us; 18us; 19us; 23us; 27us; 29us; 30us; 32us; 36us; 38us; 42us; 45us; 46us; 49us; 50us; 52us; 53us; 55us; 57us; 61us; 63us; 65us; 66us; 70us; 72us; 74us; 75us; 76us; 78us; 82us; 83us; 106us; 108us; 109us; 132us; 133us; 135us; 158us; 159us; 160us; 162us; 163us; 178us; 179us; 196us; 197us; 212us; 213us; 214us; 216us; 232us; 247us; 267us; 287us; 288us; 290us; 306us; 321us; 341us; 342us; 343us; 344us; 345us; 349us; 352us; 353us; 355us; 356us; 372us; 386us; 388us; 404us; 406us; 407us; 423us; 424us; 440us; 454us; 455us; 459us; 463us; 464us; 465us; 466us; 476us; 486us; 496us; 506us; 516us; 526us; 538us; 552us; 565us; 580us; 595us; 610us; 625us; 640us; 655us; 671us; 687us; 703us; 719us; 735us; 751us; 767us; 783us; 799us; 815us; 831us; 847us; 863us; 864us; 880us; 881us; 885us; 887us; 888us; 890us; 906us; 922us; 923us; 925us; 941us; 942us; 944us; 960us; 961us; 962us; 966us; 969us; 970us; 983us; 985us; 986us; 1002us; 1003us; 1004us; 1020us; 1021us; 1022us; 1023us; 1025us; 1026us; 1027us; 1028us; 1029us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 2us; 0us; 2us; 2us; 1us; 2us; 1us; 2us; 3us; 3us; 4us; 6us; 6us; 0us; 1us; 1us; 3us; 3us; 0us; 2us; 3us; 1us; 1us; 2us; 2us; 3us; 1us; 7us; 5us; 7us; 5us; 5us; 1us; 1us; 1us; 3us; 4us; 2us; 2us; 1us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 1us; 3us; 2us; 1us; 6us; 4us; 4us; 1us; 3us; 2us; 2us; 4us; 0us; 1us; 1us; 3us; 1us; 1us; 2us; 1us; 1us; 1us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 2us; 3us; 3us; 4us; 5us; 5us; 5us; 5us; 5us; 6us; 6us; 7us; 7us; 8us; 8us; 9us; 10us; 10us; 10us; 11us; 11us; 12us; 12us; 12us; 12us; 12us; 12us; 13us; 13us; 13us; 14us; 14us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 15us; 16us; 16us; 16us; 16us; 16us; 16us; 16us; 17us; 17us; 17us; 17us; 17us; 18us; 18us; 19us; 19us; 20us; 20us; 20us; 20us; 21us; 21us; 21us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 65535us; 16385us; 65535us; 16387us; 65535us; 16388us; 16389us; 65535us; 65535us; 65535us; 16391us; 65535us; 65535us; 65535us; 65535us; 65535us; 16393us; 65535us; 16394us; 65535us; 16395us; 65535us; 65535us; 65535us; 65535us; 65535us; 16396us; 65535us; 65535us; 65535us; 16397us; 16399us; 65535us; 65535us; 16401us; 65535us; 65535us; 16402us; 65535us; 16404us; 65535us; 65535us; 16405us; 16406us; 65535us; 16407us; 65535us; 16408us; 65535us; 16409us; 65535us; 16410us; 16411us; 65535us; 65535us; 65535us; 65535us; 65535us; 16412us; 65535us; 65535us; 65535us; 65535us; 16413us; 16414us; 16415us; 16416us; 65535us; 65535us; 16418us; 65535us; 16419us; 65535us; 65535us; 65535us; 65535us; 65535us; 16421us; 65535us; 65535us; 65535us; 65535us; 16424us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16438us; 65535us; 16439us; 65535us; 65535us; 16441us; 65535us; 65535us; 65535us; 16442us; 65535us; 65535us; 16443us; 65535us; 65535us; 16444us; 16445us; 65535us; 65535us; 16446us; 65535us; 65535us; 16448us; 65535us; 16449us; 16451us; 65535us; 16453us; 16454us; 16455us; 65535us; 16456us; 16457us; 16458us; 16459us; 16460us; |]
let _fsyacc_reductions ()  =    [| 
# 429 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Absyn.program)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startMain));
# 438 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Topdecs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 42 "CPar.fsy"
                                                               Prog _1 
                   )
# 42 "CPar.fsy"
                 : Absyn.program));
# 449 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 46 "CPar.fsy"
                                                               [] 
                   )
# 46 "CPar.fsy"
                 : 'Topdecs));
# 459 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Topdec)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Topdecs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 47 "CPar.fsy"
                                                               _1 :: _2 
                   )
# 47 "CPar.fsy"
                 : 'Topdecs));
# 471 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vardec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 51 "CPar.fsy"
                                                               Vardec (fst _1, snd _1) 
                   )
# 51 "CPar.fsy"
                 : 'Topdec));
# 482 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Fundec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 52 "CPar.fsy"
                                                               _1 
                   )
# 52 "CPar.fsy"
                 : 'Topdec));
# 493 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Type)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vardesc)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 56 "CPar.fsy"
                                                               ((fst _2) _1, snd _2) 
                   )
# 56 "CPar.fsy"
                 : 'Vardec));
# 505 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 60 "CPar.fsy"
                                                               ((fun t -> t), _1)                      
                   )
# 60 "CPar.fsy"
                 : 'Vardesc));
# 516 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vardesc)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 61 "CPar.fsy"
                                                               compose1 TypP _2                        
                   )
# 61 "CPar.fsy"
                 : 'Vardesc));
# 527 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vardesc)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 62 "CPar.fsy"
                                                               _2                                      
                   )
# 62 "CPar.fsy"
                 : 'Vardesc));
# 538 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vardesc)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 63 "CPar.fsy"
                                                               compose1 (fun t -> TypA(t, None)) _1    
                   )
# 63 "CPar.fsy"
                 : 'Vardesc));
# 549 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vardesc)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : int)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 64 "CPar.fsy"
                                                               compose1 (fun t -> TypA(t, Some _3)) _1 
                   )
# 64 "CPar.fsy"
                 : 'Vardesc));
# 561 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Paramdecs)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'Block)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 68 "CPar.fsy"
                                                               Fundec(None,     _2, _4, _6) 
                   )
# 68 "CPar.fsy"
                 : 'Fundec));
# 574 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Type)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Paramdecs)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'Block)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 69 "CPar.fsy"
                                                               Fundec(Some(_1), _2, _4, _6) 
                   )
# 69 "CPar.fsy"
                 : 'Fundec));
# 588 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 73 "CPar.fsy"
                                                               [] 
                   )
# 73 "CPar.fsy"
                 : 'Paramdecs));
# 598 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Paramdecs1)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 74 "CPar.fsy"
                                                               _1 
                   )
# 74 "CPar.fsy"
                 : 'Paramdecs));
# 609 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vardec)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 78 "CPar.fsy"
                                                               [_1]     
                   )
# 78 "CPar.fsy"
                 : 'Paramdecs1));
# 620 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vardec)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Paramdecs1)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 79 "CPar.fsy"
                                                               _1 :: _3 
                   )
# 79 "CPar.fsy"
                 : 'Paramdecs1));
# 632 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtOrDecSeq)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 83 "CPar.fsy"
                                                               Block _2 
                   )
# 83 "CPar.fsy"
                 : 'Block));
# 643 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 87 "CPar.fsy"
                                                               [] 
                   )
# 87 "CPar.fsy"
                 : 'StmtOrDecSeq));
# 653 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Stmt)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtOrDecSeq)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 88 "CPar.fsy"
                                                               Stmt _1 :: _2 
                   )
# 88 "CPar.fsy"
                 : 'StmtOrDecSeq));
# 665 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Vardec)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtOrDecSeq)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 89 "CPar.fsy"
                                                               Dec (fst _1, snd _1) :: _3 
                   )
# 89 "CPar.fsy"
                 : 'StmtOrDecSeq));
# 677 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtM)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 93 "CPar.fsy"
                                                               _1 
                   )
# 93 "CPar.fsy"
                 : 'Stmt));
# 688 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtU)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 94 "CPar.fsy"
                                                               _1 
                   )
# 94 "CPar.fsy"
                 : 'Stmt));
# 699 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 98 "CPar.fsy"
                                                               Expr(_1)             
                   )
# 98 "CPar.fsy"
                 : 'StmtM));
# 710 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 99 "CPar.fsy"
                                                               Return None          
                   )
# 99 "CPar.fsy"
                 : 'StmtM));
# 720 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 100 "CPar.fsy"
                                                               Return(Some(_2))     
                   )
# 100 "CPar.fsy"
                 : 'StmtM));
# 731 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Block)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 101 "CPar.fsy"
                                                               _1                   
                   )
# 101 "CPar.fsy"
                 : 'StmtM));
# 742 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtM)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtM)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 102 "CPar.fsy"
                                                               If(_3, _5, _7)       
                   )
# 102 "CPar.fsy"
                 : 'StmtM));
# 755 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtM)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 103 "CPar.fsy"
                                                               While(_3, _5)        
                   )
# 103 "CPar.fsy"
                 : 'StmtM));
# 767 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtM)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtU)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 107 "CPar.fsy"
                                                               If(_3, _5, _7)       
                   )
# 107 "CPar.fsy"
                 : 'StmtU));
# 780 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Stmt)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 108 "CPar.fsy"
                                                               If(_3, _5, Block []) 
                   )
# 108 "CPar.fsy"
                 : 'StmtU));
# 792 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'StmtU)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 109 "CPar.fsy"
                                                               While(_3, _5)        
                   )
# 109 "CPar.fsy"
                 : 'StmtU));
# 804 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Access)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 113 "CPar.fsy"
                                                               Access _1           
                   )
# 113 "CPar.fsy"
                 : 'Expr));
# 815 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ExprNotAccess)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 114 "CPar.fsy"
                                                               _1                  
                   )
# 114 "CPar.fsy"
                 : 'Expr));
# 826 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'AtExprNotAccess)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 118 "CPar.fsy"
                                                               _1                  
                   )
# 118 "CPar.fsy"
                 : 'ExprNotAccess));
# 837 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 119 "CPar.fsy"
                                                               Assign(_1, _3)      
                   )
# 119 "CPar.fsy"
                 : 'ExprNotAccess));
# 849 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Exprs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 120 "CPar.fsy"
                                                               Call(_1, _3)        
                   )
# 120 "CPar.fsy"
                 : 'ExprNotAccess));
# 861 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 121 "CPar.fsy"
                                                               Prim1("!", _2)      
                   )
# 121 "CPar.fsy"
                 : 'ExprNotAccess));
# 872 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 122 "CPar.fsy"
                                                               Prim1("printi", _2) 
                   )
# 122 "CPar.fsy"
                 : 'ExprNotAccess));
# 883 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 123 "CPar.fsy"
                                                               Prim1("printc", nl) 
                   )
# 123 "CPar.fsy"
                 : 'ExprNotAccess));
# 893 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 124 "CPar.fsy"
                                                               Prim2("+",  _1, _3) 
                   )
# 124 "CPar.fsy"
                 : 'ExprNotAccess));
# 905 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 125 "CPar.fsy"
                                                               Prim2("-",  _1, _3) 
                   )
# 125 "CPar.fsy"
                 : 'ExprNotAccess));
# 917 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 126 "CPar.fsy"
                                                               Prim2("*",  _1, _3) 
                   )
# 126 "CPar.fsy"
                 : 'ExprNotAccess));
# 929 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 127 "CPar.fsy"
                                                               Prim2("/",  _1, _3) 
                   )
# 127 "CPar.fsy"
                 : 'ExprNotAccess));
# 941 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 128 "CPar.fsy"
                                                               Prim2("%",  _1, _3) 
                   )
# 128 "CPar.fsy"
                 : 'ExprNotAccess));
# 953 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 129 "CPar.fsy"
                                                               Prim2("==", _1, _3) 
                   )
# 129 "CPar.fsy"
                 : 'ExprNotAccess));
# 965 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 130 "CPar.fsy"
                                                               Prim2("!=", _1, _3) 
                   )
# 130 "CPar.fsy"
                 : 'ExprNotAccess));
# 977 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 131 "CPar.fsy"
                                                               Prim2(">",  _1, _3) 
                   )
# 131 "CPar.fsy"
                 : 'ExprNotAccess));
# 989 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 132 "CPar.fsy"
                                                               Prim2("<",  _1, _3) 
                   )
# 132 "CPar.fsy"
                 : 'ExprNotAccess));
# 1001 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 133 "CPar.fsy"
                                                               Prim2(">=", _1, _3) 
                   )
# 133 "CPar.fsy"
                 : 'ExprNotAccess));
# 1013 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 134 "CPar.fsy"
                                                               Prim2("<=", _1, _3) 
                   )
# 134 "CPar.fsy"
                 : 'ExprNotAccess));
# 1025 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 135 "CPar.fsy"
                                                               Andalso(_1, _3)     
                   )
# 135 "CPar.fsy"
                 : 'ExprNotAccess));
# 1037 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 136 "CPar.fsy"
                                                               Orelse(_1, _3)      
                   )
# 136 "CPar.fsy"
                 : 'ExprNotAccess));
# 1049 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Const)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 140 "CPar.fsy"
                                                               CstI _1             
                   )
# 140 "CPar.fsy"
                 : 'AtExprNotAccess));
# 1060 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ExprNotAccess)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 141 "CPar.fsy"
                                                               _2                  
                   )
# 141 "CPar.fsy"
                 : 'AtExprNotAccess));
# 1071 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Access)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 142 "CPar.fsy"
                                                               Addr _2             
                   )
# 142 "CPar.fsy"
                 : 'AtExprNotAccess));
# 1082 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 143 "CPar.fsy"
                                                               CstN                
                   )
# 143 "CPar.fsy"
                 : 'AtExprNotAccess));
# 1092 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 144 "CPar.fsy"
                                                               Prim2("cons",_3,_5) 
                   )
# 144 "CPar.fsy"
                 : 'AtExprNotAccess));
# 1104 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 145 "CPar.fsy"
                                                               Prim1("car", _3)    
                   )
# 145 "CPar.fsy"
                 : 'AtExprNotAccess));
# 1115 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 146 "CPar.fsy"
                                                               Prim1("cdr", _3)    
                   )
# 146 "CPar.fsy"
                 : 'AtExprNotAccess));
# 1126 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 150 "CPar.fsy"
                                                               AccVar _1           
                   )
# 150 "CPar.fsy"
                 : 'Access));
# 1137 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Access)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 151 "CPar.fsy"
                                                               _2                  
                   )
# 151 "CPar.fsy"
                 : 'Access));
# 1148 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Access)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 152 "CPar.fsy"
                                                               AccDeref (Access _2)
                   )
# 152 "CPar.fsy"
                 : 'Access));
# 1159 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'AtExprNotAccess)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 153 "CPar.fsy"
                                                               AccDeref _2         
                   )
# 153 "CPar.fsy"
                 : 'Access));
# 1170 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Access)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 154 "CPar.fsy"
                                                               AccIndex(_1, _3)    
                   )
# 154 "CPar.fsy"
                 : 'Access));
# 1182 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 158 "CPar.fsy"
                                                               []       
                   )
# 158 "CPar.fsy"
                 : 'Exprs));
# 1192 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Exprs1)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 159 "CPar.fsy"
                                                               _1       
                   )
# 159 "CPar.fsy"
                 : 'Exprs));
# 1203 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 163 "CPar.fsy"
                                                               [_1]     
                   )
# 163 "CPar.fsy"
                 : 'Exprs1));
# 1214 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Expr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Exprs1)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 164 "CPar.fsy"
                                                               _1 :: _3 
                   )
# 164 "CPar.fsy"
                 : 'Exprs1));
# 1226 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 168 "CPar.fsy"
                                                               _1       
                   )
# 168 "CPar.fsy"
                 : 'Const));
# 1237 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 169 "CPar.fsy"
                                                               _1       
                   )
# 169 "CPar.fsy"
                 : 'Const));
# 1248 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : int)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 170 "CPar.fsy"
                                                               - _2     
                   )
# 170 "CPar.fsy"
                 : 'Const));
# 1259 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 171 "CPar.fsy"
                                                               -1       
                   )
# 171 "CPar.fsy"
                 : 'Const));
# 1269 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 175 "CPar.fsy"
                                                               TypI     
                   )
# 175 "CPar.fsy"
                 : 'Type));
# 1279 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 176 "CPar.fsy"
                                                               TypC     
                   )
# 176 "CPar.fsy"
                 : 'Type));
# 1289 "CPar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 177 "CPar.fsy"
                                                               TypD     
                   )
# 177 "CPar.fsy"
                 : 'Type));
|]
# 1300 "CPar.fs"
let tables () : Microsoft.FSharp.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Microsoft.FSharp.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 47;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let Main lexer lexbuf : Absyn.program =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
